<?
# TWEET NEGLECTOR
# A small PHP script to delete old tweets from Twitter
#
# Daniel Ritter
# daniel@daniel-ritter.de
# 
# http://www.daniel-ritter.de/blog/tweet-neglector-a-small-php-script-to-delete-old-tweets-from-twitter
#
# Version 0.5
# Aug 01 2013
#
# This is free software
# License http://opensource.org/licenses/gpl-license.php GNU Public License
#
# Tweet Neglector uses the Twitter-API-PHP library by James Mallison
# http://github.com/j7mbo/twitter-api-php
#
# Do what you want with it, no guarantees, it might kill your hamster.
#
#
# Configure the values below and run it from console or via cronjob
# php5 ./tweetneglector.php
#
# Enjoy


#########################################################################
#                                                                       #
#  CONFIG                                                               #
#                                                                       #
#########################################################################


# Get these values from http://dev.twitter.com
# You need to register an App there and give it read/write access
$consumer_key        =  "";
$consumer_secret 	 =  "";
$access_token      	 =  "";
$access_token_secret =  "";

# Username of the account to delete tweets from
$username			 =  "";

# Tweets older than this value in days will be deleted
$keep_days           =  "14";



#################################################################################
# No config needed below this line                                              #
#################################################################################

$starttime = time();
error_reporting(E_ALL ^  E_NOTICE); 


# Load library
require("./Twitter-API-PHP.php");

# Configure library
$settings = array(
    'oauth_access_token' => "$access_token",
    'oauth_access_token_secret' => "$access_token_secret",
    'consumer_key' => "$consumer_key",
    'consumer_secret' => "$consumer_secret"
);




echo "\n\nTweet Neglector\n";
echo "Starting the collection of tweets for $username\n";




#########################################################################
#                                                                       #
#  GET USERS TWEETS                                                     #
#                                                                       #
#########################################################################

# Twitter allows to get the last 3200 tweets of an user.
# Tweets need to be retrieved in packs of 200 tweets, APi doesn't allow more.
# So we are getting 16 times 200 tweets.
$j=0;
for ($i=1; $i<17; $i++)
{
echo "Getting tweets. Tweetpack $i of 16 \n";

# Twitter API URL for getting a users timeline..
$url = 'https://api.twitter.com/1.1/statuses/user_timeline.json';

# Configuring the GET parameters for the API call.
# First tweetpack must be recieved without "max_id"
# Following tweetpacks are being retrieved from "max_id" into the past
if ($i==1)
$getfield = "?screen_name=$username&count=200&include_rts=true";
else
$getfield = "?screen_name=$username&count=200&include_rts=true&max_id=$max_id";

# API call
$requestMethod = 'GET';
$twitter = new TwitterAPIExchange($settings);
$response = $twitter->setGetfield($getfield)
                    ->buildOauth($url, $requestMethod)
                    ->performRequest();

# Convert API result to Array
$timeline = json_decode($response,true);

# If there is an Error message from the API, print it out.
if ($timeline["errors"][0]["message"])
echo "\n\n" . "ERROR:" . $timeline["errors"][0]["message"];

    # Walk thtu the result array, tweet for tweet
    foreach ($timeline as $tweet)
    {
        # Twitter uses a non RFC date format. Converting it to UNIX timestamp here.
        $timestamp = strtotime($tweet["created_at"]);	
	
        #echo $tweet["created_at"] . " " . $timestamp . " " . $tweet["id_str"] . " ". $tweet["text"];
        #echo "\n";
        
        # If the beginning of the users tweets is reached, the oldest tweet
        # will be repeated by the API. We don't need to save these tweets, as we already have them
        if ($tweet["id_str"] == $max_id) $reached_end = 1;

        # Set "max_id" to the ID of the current tweet. We need this value for the next round of the loop,
        # to start at the right position to get the next 200 tweets
        $max_id = $tweet["id_str"];
            
            # Write the data to the result array. We need it later on to delete the tweets.
            if (!$reached_end)
            {
            $tweets[$j]["id"] = $tweet["id_str"];
            $tweets[$j]["timestamp"] = $timestamp;
            $tweets[$j]["text"] = $tweet["text"];
            $j++;
            }

    }


}

echo "Found " .  count($tweets) . " Tweets.\n\n";
$tweets_found = count($tweets);


#########################################################################
#                                                                       #
#  DELETE USERS TWEETS                                                  #
#                                                                       #
#########################################################################

$tweets_deleted = 0;
echo "\n\nDeleting tweets: ";

# Get current UNIX time
$now = time();

# Calculate the timestamp before tweets will be deleted
$del_older_than = $now - $keep_days * 86400;

# Walk thru our result array and delete tweets.


foreach ($tweets as $t)
{

    # Tweet is old enough. Delete it.
    if ($t["timestamp"] < $del_older_than)
    {

    $this_id = $t["id"];
    # Do API call
    $url = 'https://api.twitter.com/1.1/statuses/destroy/' . $this_id . '.json';
    $postfields = array("id" => "$this_id");
    $requestMethod = 'POST';
    $twitter = new TwitterAPIExchange($settings);
    $response =  $twitter->buildOauth($url, $requestMethod)
                         ->setPostfields($postfields)
                         ->performRequest();
    echo "X";
    $tweets_deleted++;
    }

    #Tweet not old enough. Do nothing.
    else
    {
    echo ".";
    }




}

#########################################################################
#                                                                       #
#  STATS                                                                #
#                                                                       #
#########################################################################


echo "\n\nTweets deleted: $tweets_deleted\n";

$tweets_kept = $tweets_found - $tweets_deleted;
echo "Tweets kept:" . $tweets_kept . "\n";

$endtime = time();
$jobtime = $endtime - $starttime;

echo "Time for job: " . $jobtime . " seconds.\n\n";

?>
